#include <stdio.h>
#include <stdlib.h>

struct list_node {
    int                value;
    struct list_node * next;
};


/* 
 * Creates a new list node, and adds it before the existing head node
 * returns a pointer to the created node, which is now the new head node
 */ 
struct list_node * 
push_value(struct list_node * cur_head,
	   int                value)
{
    struct list_node * node = calloc(1, sizeof(struct list_node));

    node->value = value;
    node->next  = cur_head;

    return node;
}


int main(int argc, char ** argv) {

    struct list_node * head = NULL;

    head = push_value(head, 1);
    head = push_value(head, 2);
    head = push_value(head, 3);
    head = push_value(head, 4);
    head = push_value(head, 5);
    head = push_value(head, 6);
    head = push_value(head, 7);
    head = push_value(head, 8);
    head = push_value(head, 9);
    head = push_value(head, 10);

    {
	
	while (head) {
	    struct list_node * tmp_node = head->next;
	    
	    printf("Value: %d\n", head->value);	    

	    free(head);	    
	    head = tmp_node;
	}
    }

    return 0;


}
