#include <stdio.h>
#include <stdlib.h>

struct list_node {
    int                value;
    struct list_node * next;
};

struct list {
    struct list_node * head;
};

		
void
insert(struct list * list,
       int           value)
{
    struct list_node * tmp_node = list->head;
    struct list_node * prev     = NULL;

    while (tmp_node) {

	if (tmp_node->value > value) {
	    break;
	}

	prev     = tmp_node;
	tmp_node = tmp_node->next;
    }


    if (!tmp_node) {
	// Just insert it
	struct list_node * new_node = calloc(1, sizeof(struct list_node));
	
	new_node->value = value;
	new_node->next  = NULL;

	if (prev) {
	    prev->next = new_node;
	} else {
	    list->head = new_node;
	}
    } else {
	struct list_node * new_node = calloc(1, sizeof(struct list_node));
	
	new_node->value = value;
	new_node->next  = tmp_node;
	
	if (prev) {
	    prev->next = new_node;
	} else {
	    list->head = new_node;
	}
		
    }

}


int
main(int argc, char ** argv)
{
    struct list my_list = { NULL };
    
    insert(&my_list, 2);
    insert(&my_list, 6);
    insert(&my_list, 4);
    insert(&my_list, 1);
    insert(&my_list, 93);
    insert(&my_list, 5);
    insert(&my_list, 23);
    insert(&my_list, 8);
    insert(&my_list, 20);
    insert(&my_list, 17);

    {
	struct list_node * tmp_node = my_list.head;
	
	while (tmp_node) {
	    printf("Value: %d\n", tmp_node->value);
	    tmp_node = tmp_node->next;
	}
    }

    return 0;


}
